<xsl:stylesheet 
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="text" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>


    <xsl:template match="result">
      
     <text xml:space="preserve"> 
$$
\begin{array}{|c|</text>

       <xsl:apply-templates select="//variables/var" mode="centering"/>

     <text xml:space="preserve">|c|}  
    &amp;</text> 
     <xsl:apply-templates select="//variables/var"/>
     <text xml:space="preserve"> weight \\\hline
</text>
     <xsl:apply-templates select="//solution"/>

    <text xml:space="preserve">\hline
\end{array}
$$
 </text>
      
    </xsl:template>
    

    <xsl:template match="var">
	<xsl:copy-of select="replace(replace(replace(replace(replace(replace(
			     concat('\',text()),
			     '\\x_', '\\x{' ),
			     '\\y_', '\\y{' ),
			     '\\o_', '\\ko{' ),
			     '\\w_', '\\w{' ),
			     '\\v_', '\\v{' ),
			     '_'   , '-'    )
  "/> 
	<text>} &amp; </text>
    </xsl:template>

    <xsl:template match="solution">
      <xsl:value-of select="position()"/>
      <text>. &amp; </text>
      <xsl:apply-templates select="@*"/>
      <xsl:value-of select="text()"/>
      <text xml:space="preserve"> \\ 
</text>
    </xsl:template>

    <xsl:template match="var" mode="centering">
      <text>c</text>
    </xsl:template>

    <xsl:template match="@*">
      <text>\</text>
      <xsl:value-of select="."/>
      <text> &amp; </text>
    </xsl:template>
    
    
</xsl:stylesheet>


