<xsl:stylesheet 
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="text" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>

    <xsl:variable name="network-id-latex-fix">
      <xsl:value-of select="replace(replace(//network/@id,
			    '-',''),
			    '_','')"/>
    </xsl:variable>
    
    <xsl:template match="//network">
     <!-- <xsl:message>
	network-id-latex-fix <xsl:copy-of select="$network-id-latex-fix"/>
      </xsl:message>
      -->
      <text xml:space="preserve">%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% network </text>
      <xsl:value-of select="@id"/>
      <text xml:space="preserve">
</text>
     <text xml:space="preserve">%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% species and their latex look 
</text>

     <xsl:apply-templates select="metabolite|actor|protein|reaction" mode="node"/>
     
     <xsl:apply-templates select="." mode="switch-macros"/>
    </xsl:template>
    
    <xsl:template match="metabolite|actor|protein|reaction" mode="node">
      <xsl:variable name="Nid">
	<xsl:value-of select="$network-id-latex-fix"/>
      </xsl:variable>
      <text>\newcommand\</text>
      <xsl:value-of select="$Nid"/>
      <xsl:value-of select="replace(replace(replace(replace(replace(
			    replace(replace(replace(replace(replace(
			    replace(replace(replace(@id,
			    '0','Zero'),
			    '1','One'),
			    '2','Two'),
	 		    '3','Three'),
			    '4','Four'),
			    '5','Five'),
			    '6','Six'),
			    '7','Seven'),
			    '8','Eight'),
			    '9','Nine'),
			    '\+','Plus'),
			    '_',''),
			    '-','')"/>
      
      <text>{</text>
      <xsl:value-of select="@id"/>
      <text xml:space="preserve">}
</text>      
      <xsl:if test="@latex-look">
	<text>\newcommand\Look</text>
	      <xsl:value-of select="$Nid"/>
	      <xsl:value-of select="replace(replace(replace(replace(replace(
			    replace(replace(replace(replace(replace(replace(
			    replace(replace(@id,
			    '0','Zero'),
			    '1','One'),
			    '2','Two'),
			    '3','Three'),
			    '4','Four'),
			    '5','Five'),
			    '6','Six'),
			    '7','Seven'),
			    '8','Eight'),
			    '9','Nine'),
			    '\+','Plus'),
			    '_',''),
			    '-','')"/> 
	<text>{</text>
	<xsl:value-of select="@latex-look"/>
	<text xml:space="preserve">}
</text>	
      </xsl:if>
    </xsl:template>
    
    <xsl:template match="network" mode="switch-macros">
      <text>%% switch macros for changing latex look
	
\renewcommand*{\LookSwitch}[1]{%
    \stringcases
    {#1}%
    {%
      </text>
      <xsl:apply-templates select="metabolite|actor|protein|reaction"
			   mode="switch-macros"/>
    <text xml:space="preserve">}%
    {#1}%
}
</text>
    </xsl:template>

    <xsl:template match="reaction|metabolite|actor|protein" mode="switch-macros">
      <xsl:if test="@latex-look">
	<text>{</text>
	<xsl:value-of select="@id"/>
	<text>}{\Look</text>
	<xsl:value-of select="$network-id-latex-fix"/>
	 <xsl:value-of select="replace(replace(replace(replace(replace(
			    replace(replace(replace(replace(replace(replace(
			    replace(replace(@id,
			    '0','Zero'),
			    '1','One'),
			    '2','Two'),
			    '3','Three'),
			    '4','Four'),
			    '5','Five'),
			    '6','Six'),
			    '7','Seven'),
			    '8','Eight'),
			    '9','Nine'),
			    '\+','Plus'),
			    '_',''),
			    '-','')"/>
	<text xml:space="preserve">}%
	</text>
      </xsl:if>

      <xsl:if test="@latex-look and not(name()='reaction')">
	<text>{\</text>
	<xsl:value-of select="@id"/>
	<text>}{\Look</text>
	<xsl:value-of select="$network-id-latex-fix"/>
	 <xsl:value-of select="replace(replace(replace(replace(replace(
			    replace(replace(replace(replace(replace(replace(
			    replace(replace(@id,
			    '0','Zero'),
			    '1','One'),
			    '2','Two'),
			    '3','Three'),
			    '4','Four'),
			    '5','Five'),
			    '6','Six'),
			    '7','Seven'),
			    '8','Eight'),
			    '9','Nine'),
			    '\+','Plus'),
			    '_',''),
			    '-','')"/>
	<text xml:space="preserve">}%
	</text>
      </xsl:if>
      
      <xsl:if test="@latex-look">
	<text>{\</text>
	<xsl:value-of select="$network-id-latex-fix"/>
	<xsl:value-of select="replace(replace(replace(replace(replace(
			      replace(replace(replace(replace(replace(replace(
			      replace(replace(@id,
			      '0','Zero'),
			      '1','One'),
			      '2','Two'),
			      '3','Three'),
			      '4','Four'),
			      '5','Five'),
			      '6','Six'),
			      '7','Seven'),
			      '8','Eight'),
			      '9','Nine'),
			      '\+','Plus'),
			      '_',''),
			      '-','')"/>
	<text>}{\Look</text>
	<xsl:value-of select="$network-id-latex-fix"/>
	<xsl:value-of select="replace(replace(replace(replace(replace(
			      replace(replace(replace(replace(replace(replace(
			      replace(replace(@id,
			      '0','Zero'),
			      '1','One'),
			      '2','Two'),
			      '3','Three'),
			      '4','Four'),
			      '5','Five'),
			      '6','Six'),
			      '7','Seven'),
			      '8','Eight'),
			      '9','Nine'),
			      '\+','Plus'),
			      '_',''),
			      '-','')"/>
	<text xml:space="preserve">}%
	</text>
      </xsl:if>

    </xsl:template>
        
    

</xsl:stylesheet>
