<xsl:stylesheet 
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="text" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>
    
    <xsl:strip-space elements="*" />
      
    <xsl:template match="/">

      <xsl:variable name="full-id">
	<xsl:value-of select="network/@id"/>
	<xsl:if test="network/@kind">
	  <text>-</text>
	  <xsl:value-of select="network/@kind"/>
	</xsl:if>
      </xsl:variable>
      
      <text xml:space="preserve">\renewcommand\TIKZID[1]{</text>
      <xsl:value-of select="$full-id"/>
      <text xml:space="preserve">}
\renewcommand\TIKZREFID[1]{</text>
      <xsl:value-of select="$full-id"/>
      <text>}

\begin{longtable}{|l||l|}
\hline
Name      &amp;  Function 
\\\hline\hline
</text>

      <xsl:apply-templates select="//network"/>

      <text xml:space="preserve">\hline\hline
\end{longtable}
</text>
      
    </xsl:template>
    
    <xsl:template match="//network"> 
      <xsl:variable name="reactions">
	<xsl:apply-templates select="reaction"/>
      </xsl:variable>

      <xsl:value-of select="$reactions"/>
    </xsl:template>

    <xsl:template match="@experiment">
      <text>experiment: </text>
      <xsl:value-of select="."/>
    </xsl:template>
    <xsl:template match="@prediction">
      <text>predition: </text>
      <xsl:value-of select="."/>
    </xsl:template>
    <xsl:template match="@*">
      <xsl:value-of select="."/>
    </xsl:template>
    
   <xsl:template match="reaction">
     <text xml:space="preserve">\Rtable{<xsl:value-of select="normalize-space(@id)"/>}&amp; <xsl:value-of select="@comment"/>
\\
</text>
      <xsl:for-each select="comment">
	<text xml:space="preserve"> &amp;
	<xsl:apply-templates select="@*"/>
\\
</text>
     </xsl:for-each>
     <xsl:if test="product-inh">
        <text xml:space="preserve">\RtableDEG{<xsl:value-of select="normalize-space(@id)"/>}&amp; degradation of \M{</text>
	<xsl:value-of select="product-inh/@spec"/>
	<text xml:space="preserve">}\\
</text>
     </xsl:if>
   </xsl:template>

</xsl:stylesheet>
