<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="xml" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>

    <xsl:template match="//network"> 
      <xsl:apply-templates select="." mode="stoichiometry"/>
    </xsl:template>
    
    <!-- function stoichiometry -->
    
    <xsl:template match="network" mode="stoichiometry">
      <network>
	<xsl:copy-of select="@*"/>
	<xsl:copy-of select="*[not(self::reaction)]"/>
	<xsl:apply-templates select="reaction" mode="stoichiometry" />
      </network>
    </xsl:template>
    
    <xsl:template match="reaction" mode="stoichiometry">
      <reaction>
	<xsl:copy-of select="@*"/>
	<xsl:copy-of select="*[not(self::product or self::reactant or self::product-inh)]"/>
	<xsl:apply-templates select="product|reactant|product-inh" mode="stoichiometry"/>
      </reaction>
    </xsl:template>
    
    <xsl:template match="product|reactant|product-inh" mode="stoichiometry">
      <xsl:choose>
	<xsl:when test="not(@spec=preceding-sibling::*[self::product 
		      or self::reactant or self::product-inh]/@spec)">
	  <xsl:variable name="tag">
	    <xsl:value-of select="name(.)"/>
	  </xsl:variable>
	  <xsl:variable name="spec">
	    <xsl:value-of select="@spec"/>
	  </xsl:variable>
	  <xsl:element name="{$tag}">     
	    <xsl:copy-of select="@*"/>
	    <xsl:attribute name="stoichiometry">
	      <xsl:value-of select="count(parent::*/product[@spec=$spec])
				    + count(parent::*/product-inh[@spec=$spec])
				 - count(parent::*/reactant[@spec=$spec])"/>
	    </xsl:attribute>
	  </xsl:element>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:copy-of select="."/>
	</xsl:otherwise>
    </xsl:choose>
    </xsl:template>
    
    <xsl:template match="*|@*" mode="stoichiometry">
      <xsl:copy-of select="."/>
    </xsl:template>

</xsl:stylesheet>
