###############################################################
### Generiert eine HTML Datei gegeben eine  HTML-Schablone, 
### die ausser HTML-Kommandos auch Referenten entlt, 
### und Datenbank mit Referentendefinitionen.
###############################################################


my %ref = ();                       # creates a hash for referents

###############################################################
# Lese Referenten aus einer Datenbank 
# und schreibe sie in einen Hash
###############################################################

sub readreferents{

  &GetOptions("urls=s" => \$urls)    # ffne Datenbank
  open URLs, $urls or die "Couldn't open URLs at $urls: $!";

  while (<URLs>) {                   # Lese Zeilen der Datenbank.
     chomp $_;                       # Lsche Newline am Ende der Zeile.
     s/#.*\n$//                      # Lsche Kommentare.
     if (/^[\s]*$/ {next};           # Ignoriere Leerzeile.
     m/(\w*)\s*=\s*(\w*)\s*/;        # Matche den Referenten links
                                     #    und seine Definition rechts.
     $ref{$1} = $2;                  # Schreibe die Definition in
                                     #    den Referenten Hash.

  close URLs;                        # schliesse Datenbank
  return 1;                          # Ausgabe egal.
  }

###############################################################
# Lese HTML-File und ersetze alle Referenten durch
# ihre Definition im Referenten-Hash
###############################################################

sub processhtmlfile {

  &GetOptions("html"=s => \$html)    # ffne HTML-file
  open HTML, $html or die "Couldn't open HTML file at $html: $!";
 
  while (<HTML>) {
     foreach $referent (keys(%ref))  # ersetze Referenten
       {s/\$$referent/$ref{$referent}/};
     };
  print $_;                          # gebe Zeile aus
  close HTML;                        # Ausgabe egal.
  return 1
  } 

###############################################################
# Hauptprogram
###############################################################
   
   print "#this is a generated html file. Please don't edit it.";
   $_ = readreferents();
   $_ = processhtmlfile();









