###############################################################
### Generiert eine HTML Datei aus einer HTML-Schablone, 
### die ausser HTML-Kommandos auch Referenten entlt, 
### und Datenbank mit Referentendefinitionen.
###############################################################

use Getopt::Long;

my %ref = ();                       # creates a hash for referents

my $umlaut = "";  
my $dots = ".,\'-"; #-";             # Sonderzeichen drfen nur im 
                                    # Inneren aber 
                                    # nicht am Anfang oder Ende 
                                    # von Referentenstrings stehen


###############################################################
# Lese Referenten aus einer Datenbank 
# und schreibe sie in einen Hash
###############################################################

&GetOptions("urls=s" => \$urls,"html=s" => \$html);   # ffne Dateien

sub readreferents{

  open URLs, $urls or die "Couldn't open URLs at $urls: $!";

  while (<URLs>) {                   # Lese Zeilen der Datenbank.
     chomp $_;                       # Lsche Newline am Ende der Zeile.
     s/#.*$//;                       # Lsche Kommentare.
     if (/^\s*$/) {next;};           # Ignoriere Leerzeile.
     m/^\s*([\w$umlaut$dots]*)\s*=\s*([\S].*)\s*$/;  
                                     # Matche den Referenten links
                                     # und seine Definition rechts. 
     $ref{$1}=$2;                    # Schreibe Definition in Hash
     };
  close URLs;                        # schliesse Datenbank
  return 1;                          # Ausgabe egal.
  }

###############################################################
# Lese HTML-File und ersetze alle Referenten durch
# ihre Definition im Referenten-Hash
###############################################################

sub processline {$_=shift;
   while (m/\$([\w$umlaut$dots]*[\w$umlaut])/) {
       $def=$ref{$1};
       s/\$$1/$def/;                 # setze Definitionen wiederholt fr
       };                            # Referenten ein, bis alle Referenten
                                     # eliminiert sind.
   return $_;
   }
   
sub processhtmlfile {

  open HTML, $html or die "Couldn't open HTML file at $html: $!";
 
  while (<HTML>) {
     print(processline($_));
     };
  close HTML;                        # Ausgabe egal.
  return 1;
  } 

###############################################################
# Hauptprogram
###############################################################

#   print "<!--This is a generated html file. Please don't edit it.-->\n";
   $_ = readreferents();
   $_ = processhtmlfile();









