###############################################################
### Generiert eine HTML Datei aus einer HTML-Schablone, 
### die ausser HTML-Kommandos auch Referenten entlt, 
### und Datenbank mit Referentendefinitionen.
###############################################################

use Getopt::Long;


###############################################################
# Lese Link aus einer Datenbank 
# und schreibe sie in einen Hash
###############################################################

&GetOptions("links=s" => \$links);   # ffne Dateien

open LINKS, $links or die "Couldn't open links at $links: $!";

#print $links;

sub processlinks{

  while (<LINKS>) {                  # Lese Zeilen der Datenbank.
     s/#.*$//;                       # Lsche Kommentare.
     if (/^\s*$/) {next;};           # Ignoriere Leerzeile.
     chomp($_);                      # Lsche Newline am Ende der Zeile
     $ref = processlink($_);         # Erzeuge Referente fr den Link
     print($ref);
     };
  close LINKS;                       # schliesse Datenbank
  return 1;                          # Ausgabe egal.
  }

###############################################################
# Konvertiere die Link Definition zu einem Referenten
# auf den HTML Code fr den Weblink
###############################################################

my $umlaut = ""; 
my $dots = ".,\'-";                  #,-\'";                

sub processlink {$_=shift;
  m/([\w$umlaut$dots\s]*)=(.*)/;    # Match die linke und rechte
                                    # Seite der Gleichung
  $_=$1;                         
  $webpage=$2;                      # Die URL $webpage steht rechts.
  s/\s*$//;                         # Lscht Whitespace links. 
  $name=$_;                         # Merkt sich die linke Seite 
                                    #    als Druckname $name des Links.
  s/\s//g;                          # lscht alle Whitespace.
  $linkname=$_;                     # Merkt sich das Resultat $linkname
                                    #    als Referenten auf den Link 
  $_=$webpage;                     
  s/^\s*//;                         # Lscht Whitespace links und
  s/\s*$//;                         #    rechts der URL
  $webpage=$_;
#  $toplink  = "<a href=\"$webpage\" target=\"_top\>$name</a>";
#  $mainlink = "<a href=\"$webpage\" target=\"main\">$name</a>";
#  $greenlink = "<a href=\"$webpage\" target=\"_top\"><font color=\"green\">$name</font></a>";
  $toplink  = "<a href=\"$webpage\">$name</a>";
  $mainlink = "<a href=\"$webpage\">$name</a>";
  $greenlink = "<a href=\"$webpage\"><font color=\"green\">$name</font></a>";

  return "link$linkname = $toplink\nmain$linkname= $mainlink\ngreen$linkname= $greenlink\n";
  }
   
###############################################################
# Hauptprogram
###############################################################

   $_ = processlinks();









