<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
    xmlns="http://www.w3.org/1999/xhtml"   
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0">
  <xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes" />

  <xsl:template match="/">
    <text xml:space="preserve">&lt;?xml version="1.0" encoding="utf-8"?&gt;


&lt;xml&gt;    
</text>
   <xsl:apply-templates select="." mode="convert"/>
   <text xml:space="preserve">
&lt;/xml&gt;    
</text>

  </xsl:template>
  
  <xsl:template match="*" mode="convert">
    <text>&amp;lt;</text>
    <xsl:value-of select="name()"/>
    <xsl:if test="@*">
      <text xml:space="preserve"> </text>
    </xsl:if>
    <xsl:apply-templates select="@*"  mode="convert"/>
    <text>&amp;gt;</text>
    <xsl:apply-templates select="child::* | text() | comment() " mode="convert"/>
    <text>&amp;lt;/</text>
    <xsl:value-of select="name()"/>
    <text>&amp;gt;</text>    
  </xsl:template>

  <xsl:template match="*[not(child::* or comment() or text())]" mode="convert">
    <text>&amp;lt;</text>
    <xsl:value-of select="name()"/>
    <xsl:if test="@*">
      <text xml:space="preserve"> </text>
    </xsl:if>
    <xsl:apply-templates select="@*"  mode="convert"/>
    <text>/&amp;gt;</text>    
  </xsl:template>

  <xsl:template match="text()"  mode="convert">
    <xsl:value-of select="."/>
  </xsl:template>
  
  <xsl:template match="@*"  mode="convert">
    <xsl:value-of select="name()"/>
    <text>="</text>
    <xsl:value-of select="."/>
    <text>"</text>
    <xsl:apply-templates select="." mode="last"/>
  </xsl:template>

  <!-- the order on the attribute names is not the same as the order in the
       input file, which is the same as in the output file.
       Therefore, I don't see haw to supress the space after
       the last attribute of an element in the output file -->
  <xsl:template match="@*[not(name() &lt; parent::*/@*/name())]" mode="last">
    <text xml:space="preserve"> </text>
  </xsl:template>
  
  <xsl:template match="@*[name() &lt; parent::*/@*/name()]" mode="last">
    <text xml:space="preserve"> </text>
  </xsl:template>
  
  <xsl:template match="comment()"  mode="convert">
    <text>&amp;lt;!--</text>
    <xsl:value-of select="."/>
    <text>--&amp;gt;</text>
  </xsl:template>

</xsl:stylesheet>
