<?xml version="1.0" encoding="utf-8"?>
<iso:schema
  xmlns="http://purl.oclc.org/dsdl/schematron" 
  xmlns:iso="http://purl.oclc.org/dsdl/schematron"
  xmlns:dp="http://www.dpawson.co.uk/ns#"
  queryBinding='xslt2'
  schemaVersion='ISO19757-3'>

  <iso:title>Validate reaction networks</iso:title>
  <iso:ns prefix='dp' uri='http://www.dpawson.co.uk/ns#'/> 

  <iso:pattern>
    <iso:rule context="network/child::*[self::reaction or self::context]">

      <iso:assert flag="error" 
		  test="not(@id=preceding-sibling::*[self::reaction or self::context]/@id)">Id of reaction is not unique: &lt;<iso:value-of select="name()"/> id="<iso:value-of select="@id"/>" ... &gt;  Some other reaction, inflow or outflow has the same id.
      </iso:assert>  
    </iso:rule>
  
    <iso:rule  context="network/child::*[self::protein or self::metabolite or self::actor]">
      <iso:assert flag="error"
		  test="not(@id=preceding-sibling::*[self::protein or self::metabolite or self::actor]/@id)">of species  is not unique: &lt;<iso:value-of select="name()"/> id="<iso:value-of select="@id"/>" ... &gt; Some other metabolites, protein, or actor has the same id.
      </iso:assert>  
    </iso:rule>


    <iso:rule context="network/child::reaction/child::*[@spec]">
      <iso:assert flag="error"
         test="@spec=//*[self::protein or self::actor or self::metabolite]/@id">species used by reaction but not introduced: &lt;<iso:value-of select="name()"/> spec="<iso:value-of select="@spec"/>" ... &gt;</iso:assert>  
    </iso:rule>

  </iso:pattern>


</iso:schema>